import clojure.lang.*
import java.util.concurrent.Callable

public class Account  {
  Ref currentBalance
  
  Account(final int initialBalance) { 
    currentBalance = new Ref(initialBalance) 
  }
  
  void deposit(final int amount) {
    LockingTransaction.runInTransaction {
      if (amount > 0) currentBalance.set(getBalance() + amount)    
      null           
    }
  }
  
  boolean withdraw(final int amount) {
    LockingTransaction.runInTransaction {
      if(amount < 0 || getBalance() < amount)
        throw new RuntimeException("Not enough money")
      currentBalance.set(getBalance() - amount) 
      null
    }
  }

  int getBalance() { currentBalance.deref() }
}